︠3b0f19ab-0f8a-45a9-9815-112bd90f03cbi︠
%html
<h1>Writing a number in binary</h1>

︡2209ddb3-8246-40b3-b694-ef0e4e8e0f9b︡{"html": "<h1>Writing a number in binary</h1>"}︡
︠7f5ac129-23ee-4bfe-8953-85ae8cf80fbf︠
def write_in_binary(m):
    digits = []
    while m:        
        if m%2: digits.append(1)
        else: digits.append(0)
        m = m//2
    return digits
︡11b1838e-e262-4672-b056-da6fc31130a4︡︡
︠e550ab71-22f6-4709-9165-e0e9b681f1d3︠
write_in_binary(521)
︡e933a58a-7fbc-4e59-bb08-33316dd987ba︡{"stdout": "[1, 0, 0, 1, 0, 0, 0, 0, 0, 1]"}︡
︠956b4e97-2011-45ca-b448-5fe0368bfabf︠
1 + 0*2 + 0*2^2 + 2^3 + 0*2^4 + 0*2^5 + 0*2^6 + 0*2^7 + 0*2^8 + 2^9
︡68dc9f11-3189-4947-ba45-529770a7fa92︡{"stdout": "521"}︡
︠68d9a5e5-d289-4374-b6bb-cee4491b61d4︠
Mod(7,100)^25
︡b0b1c8cf-ac8a-4499-b1f2-22d4aa496a49︡{"stdout": "7"}︡
︠c5b41c06-6af2-468c-9298-46ad42fa67dfi︠
%html
<p><strong>Problem:</strong> Compute $3^{521} \pmod{10000}$.</p>

︡cf9d0d33-01b2-40c4-9b71-74c0a5cdbd0f︡{"html": "<p><strong>Problem:</strong> Compute $3^{521} \\pmod{10000}$.</p>"}︡
︠af5ab52a-d704-4a50-b93b-d74df5aa87b0︠
m = 521
n = 10000
a = 3
︡62a2351b-5b62-483c-99d3-f201e9133438︡︡
︠22bf3827-855e-4a9a-bfff-9eda8601ca10︠
m
︡54378954-5bb9-4b8c-97bc-cce44d6d7f0f︡{"stdout": "521"}︡
︠3c7e8380-9ac6-41e3-85f9-30df0e560e8b︠
m.digits(2)
︡5fe25b52-182c-4e20-8877-3076b1b2e285︡{"stdout": "[1, 0, 0, 1, 0, 0, 0, 0, 0, 1]"}︡
︠6fb3911d-45b5-4e50-a134-a806ee2ca5e4︠
m.str(2)
︡ee9a72d3-3c37-4ae8-a7c8-51fb1c7bfb59︡{"stdout": "'1000001001'"}︡
︠33fa8147-af4b-42b2-9b0c-2036c0653da7︠
m == 2^9 + 2^3 + 1
︡f48bac82-8183-4cda-8e12-27e373ea6e45︡{"stdout": "True"}︡
︠5143b848-3ddb-47b9-927f-b625dd5e726d︠
abar = Mod(a,n)
︡8cca67e1-fb7b-4ae0-a466-14fd60899014︡︡
︠e524ee66-d89e-49f2-9a34-6902c80c18b1︠
abar^(2^9 + 2^3 + 1)
︡bb2bcb81-dd9f-469c-a438-fc9309b100ba︡{"stdout": "3203"}︡
︠4e44e9fc-c0bd-4d28-a965-dbbcc10794c5︠
Mod(a,n)^m
︡06dde87a-9f1e-4cea-b025-662e3312345a︡{"stdout": "3203"}︡
︠f76fa93d-a1a3-4bba-913b-faa7cd768c88︠
abar * ((abar^2)^2)^2 * (((((((((abar^2)^2)^2)^2)^2)^2)^2)^2)^2)
︡c882ac2d-5423-4e06-8a4c-274607b98e32︡{"stdout": "3203"}︡
︠bf0a9e38-e44b-4a5b-8a35-0540b142921bi︠
%html
<h1>Exponentiation Mod n Calculator</h1>

︡9ade4c4f-995e-44d5-904a-c05263f54b10︡{"html": "<h1>Exponentiation Mod n Calculator</h1>"}︡
︠d3a8a624-c32d-4e48-9034-3abea3c83124a︠
%auto
@interact
def _(a = 2, m = 4, n = 100):
    print "%s = (%s)_2    (in binary)"%(m, m.str(2))
    print "%s^%s = %s  (mod %s)"%(a, m, Mod(a,n)^m, n)
︡cbc53e25-416f-486b-a2cb-ef19af681b3b︡{"html": "<!--notruncate--><div padding=6 id=\"div-interact-16\"> <table width=800px height=20px bgcolor=\"#c5c5c5\"\n                 cellpadding=15><tr><td bgcolor=\"#f9f9f9\" valign=top align=left><table><tr><td align=right><font color=\"black\">a&nbsp;</font></td><td><input type=\"text\" value=\"2\" size=80 onchange=\"interact(16, '_interact_.update(\\'16\\', \\'a\\', 1, _interact_.standard_b64decode(\\''+encode64(this.value)+'\\'), globals()); _interact_.recompute(\\'16\\');')\"></input></td></tr>\n<tr><td align=right><font color=\"black\">m&nbsp;</font></td><td><input type=\"text\" value=\"4\" size=80 onchange=\"interact(16, '_interact_.update(\\'16\\', \\'m\\', 2, _interact_.standard_b64decode(\\''+encode64(this.value)+'\\'), globals()); _interact_.recompute(\\'16\\');')\"></input></td></tr>\n<tr><td align=right><font color=\"black\">n&nbsp;</font></td><td><input type=\"text\" value=\"100\" size=80 onchange=\"interact(16, '_interact_.update(\\'16\\', \\'n\\', 3, _interact_.standard_b64decode(\\''+encode64(this.value)+'\\'), globals()); _interact_.recompute(\\'16\\');')\"></input></td></tr>\n</table><div id=\"cell-interact-16\"><?__SAGE__START>\n        <table border=0 bgcolor=\"white\" width=100% height=100%>\n        <tr><td bgcolor=\"white\" align=left valign=top><pre><?__SAGE__TEXT></pre></td></tr>\n        <tr><td  align=left valign=top><?__SAGE__HTML></td></tr>\n        </table><?__SAGE__END></div></td>\n                 </tr></table></div>\n                 "}︡
︠00fb1d89-a95a-46f6-8592-db6f9ef64c79i︠
%html
<h1>Our First Primality Test</h1>
<p>If $2^{n-1} \equiv 1 \pmod{n}$ then $n$ has a chance of being prime.</p>

︡0eaa532a-f95f-46e9-b8a6-70c78dad3206︡{"html": "<h1>Our First Primality Test</h1>\r\n<p>If $2^{n-1} \\equiv 1 \\pmod{n}$ then $n$ has a chance of being prime.</p>"}︡
︠52023af1-8ac2-47e6-8fe6-8c6fb3492c86︠
# Is 323 prime?  Nope!
Mod(2,323)^322
︡0dc42f05-ffb7-474c-af25-dd433ce3f8cc︡{"stdout": "157"}︡
︠50c1e89e-a408-4528-9ad6-583ffb1895e0︠
# Is 341 prime?  Maybe!  But, not for sure.
Mod(2, 341)^340
︡eb9298ed-6a24-4928-b5d6-390bad220f44︡{"stdout": "1"}︡
︠e89203f1-0845-413c-a569-c6f9eb88b68d︠
# What about a big odd random number?  
# Nope, but this doesn't give any info about a factorization!   
set_random_seed(0)
n = 2*ZZ.random_element(10^50)+1
print n
time print Mod(2,n)^(n-1)
︡4f912d9b-6ff6-43f8-a8bf-785ef720dcca︡{"stdout": "172693837716124418522092982979366532296314630498967\n79829587767292159558640084729953131077372528003242\nTime: CPU 0.00 s, Wall: 0.00 s"}︡
︠bb4f3493-6bf7-43be-9cd8-912c4cd0844b︠
time factor(n)
︡24ff5d7c-715c-41dc-a4a7-699e0f264a0b︡{"stdout": "3 * 449862907000167013519 * 127960344532295706107782898131\nTime: CPU 1.70 s, Wall: 1.70 s"}︡
︠7c2d5fe3-3727-4cf7-bb35-bf168f6fcb24a︠
%auto
def maybe_prime(n):
    return 2.powermod(n-1,n) == 1
︡6ecd4baf-4b67-484e-b7e3-91a624a99711︡︡
︠cdc99b3a-8ff0-48e6-b9d1-864271dc77a9︠
maybe_prime(2011)
︡3fe67807-c372-40c8-a965-2c2581b41dbb︡{"stdout": "True"}︡
︠37397c86-6aef-458b-a02a-241820546744a︠
%auto
@interact
def _(up_to=(100,110,..,30000)):
    fails = 0
    v = [3..up_to]
    print "Fails for n =",
    for n in v:
        if maybe_prime(n) != is_prime(n):
            print n,
            fails += 1
    
    print "\n\nPrimality test using 2 fails %s percent of the time"%(100*float(fails) / len(v))
︡dcba5068-cb6e-4985-8b12-e98ce9bbaabe︡{"html": "<!--notruncate--><div padding=6 id=\"div-interact-25\"> <table width=800px height=20px bgcolor=\"#c5c5c5\"\n                 cellpadding=15><tr><td bgcolor=\"#f9f9f9\" valign=top align=left><table><tr><td align=right><font color=\"black\">up_to&nbsp;</font></td><td><table><tr><td>\n        <div id=\"slider-up_to-25\" style=\"margin:0px; margin-left: 1.0em; margin-right: 1.0em; width: 15.0em;\"></div>\n        </td><td><font color=\"black\" id=\"slider-up_to-25-lbl\"></font></td></tr></table><script>(function(){ var values = [\"100\",\"150\",\"210\",\"270\",\"330\",\"390\",\"450\",\"510\",\"570\",\"630\",\"690\",\"750\",\"810\",\"870\",\"930\",\"990\",\"1050\",\"1110\",\"1170\",\"1230\",\"1290\",\"1350\",\"1410\",\"1470\",\"1530\",\"1590\",\"1650\",\"1710\",\"1770\",\"1830\",\"1890\",\"1950\",\"2010\",\"2070\",\"2130\",\"2190\",\"2250\",\"2310\",\"2370\",\"2430\",\"2490\",\"2550\",\"2610\",\"2670\",\"2730\",\"2790\",\"2850\",\"2910\",\"2970\",\"3030\",\"3090\",\"3150\",\"3210\",\"3270\",\"3330\",\"3390\",\"3450\",\"3510\",\"3570\",\"3630\",\"3690\",\"3750\",\"3810\",\"3870\",\"3930\",\"3990\",\"4050\",\"4110\",\"4170\",\"4230\",\"4290\",\"4350\",\"4410\",\"4470\",\"4530\",\"4590\",\"4650\",\"4710\",\"4770\",\"4830\",\"4890\",\"4950\",\"5010\",\"5070\",\"5130\",\"5190\",\"5250\",\"5310\",\"5370\",\"5430\",\"5490\",\"5550\",\"5610\",\"5670\",\"5730\",\"5790\",\"5850\",\"5910\",\"5970\",\"6030\",\"6090\",\"6150\",\"6210\",\"6270\",\"6330\",\"6390\",\"6450\",\"6510\",\"6570\",\"6630\",\"6690\",\"6750\",\"6810\",\"6870\",\"6930\",\"6990\",\"7050\",\"7110\",\"7170\",\"7230\",\"7290\",\"7350\",\"7410\",\"7470\",\"7530\",\"7580\",\"7640\",\"7700\",\"7760\",\"7820\",\"7880\",\"7940\",\"8000\",\"8060\",\"8120\",\"8180\",\"8240\",\"8300\",\"8360\",\"8420\",\"8480\",\"8540\",\"8600\",\"8660\",\"8720\",\"8780\",\"8840\",\"8900\",\"8960\",\"9020\",\"9080\",\"9140\",\"9200\",\"9260\",\"9320\",\"9380\",\"9440\",\"9500\",\"9560\",\"9620\",\"9680\",\"9740\",\"9800\",\"9860\",\"9920\",\"9980\",\"10040\",\"10100\",\"10160\",\"10220\",\"10280\",\"10340\",\"10400\",\"10460\",\"10520\",\"10580\",\"10640\",\"10700\",\"10760\",\"10820\",\"10880\",\"10940\",\"11000\",\"11060\",\"11120\",\"11180\",\"11240\",\"11300\",\"11360\",\"11420\",\"11480\",\"11540\",\"11600\",\"11660\",\"11720\",\"11780\",\"11840\",\"11900\",\"11960\",\"12020\",\"12080\",\"12140\",\"12200\",\"12260\",\"12320\",\"12380\",\"12440\",\"12500\",\"12560\",\"12620\",\"12680\",\"12740\",\"12800\",\"12860\",\"12920\",\"12980\",\"13040\",\"13100\",\"13160\",\"13220\",\"13280\",\"13340\",\"13400\",\"13460\",\"13520\",\"13580\",\"13640\",\"13700\",\"13760\",\"13820\",\"13880\",\"13940\",\"14000\",\"14060\",\"14120\",\"14180\",\"14240\",\"14300\",\"14360\",\"14420\",\"14480\",\"14540\",\"14600\",\"14660\",\"14720\",\"14780\",\"14840\",\"14900\",\"14960\",\"15020\",\"15070\",\"15130\",\"15190\",\"15250\",\"15310\",\"15370\",\"15430\",\"15490\",\"15550\",\"15610\",\"15670\",\"15730\",\"15790\",\"15850\",\"15910\",\"15970\",\"16030\",\"16090\",\"16150\",\"16210\",\"16270\",\"16330\",\"16390\",\"16450\",\"16510\",\"16570\",\"16630\",\"16690\",\"16750\",\"16810\",\"16870\",\"16930\",\"16990\",\"17050\",\"17110\",\"17170\",\"17230\",\"17290\",\"17350\",\"17410\",\"17470\",\"17530\",\"17590\",\"17650\",\"17710\",\"17770\",\"17830\",\"17890\",\"17950\",\"18010\",\"18070\",\"18130\",\"18190\",\"18250\",\"18310\",\"18370\",\"18430\",\"18490\",\"18550\",\"18610\",\"18670\",\"18730\",\"18790\",\"18850\",\"18910\",\"18970\",\"19030\",\"19090\",\"19150\",\"19210\",\"19270\",\"19330\",\"19390\",\"19450\",\"19510\",\"19570\",\"19630\",\"19690\",\"19750\",\"19810\",\"19870\",\"19930\",\"19990\",\"20050\",\"20110\",\"20170\",\"20230\",\"20290\",\"20350\",\"20410\",\"20470\",\"20530\",\"20590\",\"20650\",\"20710\",\"20770\",\"20830\",\"20890\",\"20950\",\"21010\",\"21070\",\"21130\",\"21190\",\"21250\",\"21310\",\"21370\",\"21430\",\"21490\",\"21550\",\"21610\",\"21670\",\"21730\",\"21790\",\"21850\",\"21910\",\"21970\",\"22030\",\"22090\",\"22150\",\"22210\",\"22270\",\"22330\",\"22390\",\"22450\",\"22510\",\"22560\",\"22620\",\"22680\",\"22740\",\"22800\",\"22860\",\"22920\",\"22980\",\"23040\",\"23100\",\"23160\",\"23220\",\"23280\",\"23340\",\"23400\",\"23460\",\"23520\",\"23580\",\"23640\",\"23700\",\"23760\",\"23820\",\"23880\",\"23940\",\"24000\",\"24060\",\"24120\",\"24180\",\"24240\",\"24300\",\"24360\",\"24420\",\"24480\",\"24540\",\"24600\",\"24660\",\"24720\",\"24780\",\"24840\",\"24900\",\"24960\",\"25020\",\"25080\",\"25140\",\"25200\",\"25260\",\"25320\",\"25380\",\"25440\",\"25500\",\"25560\",\"25620\",\"25680\",\"25740\",\"25800\",\"25860\",\"25920\",\"25980\",\"26040\",\"26100\",\"26160\",\"26220\",\"26280\",\"26340\",\"26400\",\"26460\",\"26520\",\"26580\",\"26640\",\"26700\",\"26760\",\"26820\",\"26880\",\"26940\",\"27000\",\"27060\",\"27120\",\"27180\",\"27240\",\"27300\",\"27360\",\"27420\",\"27480\",\"27540\",\"27600\",\"27660\",\"27720\",\"27780\",\"27840\",\"27900\",\"27960\",\"28020\",\"28080\",\"28140\",\"28200\",\"28260\",\"28320\",\"28380\",\"28440\",\"28500\",\"28560\",\"28620\",\"28680\",\"28740\",\"28800\",\"28860\",\"28920\",\"28980\",\"29040\",\"29100\",\"29160\",\"29220\",\"29280\",\"29340\",\"29400\",\"29460\",\"29520\",\"29580\",\"29640\",\"29700\",\"29760\",\"29820\",\"29880\",\"29940\",\"30000\"]; setTimeout(function() {\n    $('#slider-up_to-25').slider({\n        step: 1, min: 0, max: 499, value: 0,\n        change: function (e,ui) { var position = ui.value; if(values!=null) $('#slider-up_to-25-lbl').text(values[position]); interact(25, '_interact_.update(\\'25\\', \\'up_to\\', 4, _interact_.standard_b64decode(\\''+encode64(position)+'\\'), globals()); _interact_.recompute(\\'25\\');'); },\n        slide: function(e,ui) { if(values!=null) $('#slider-up_to-25-lbl').text(values[ui.value]); }\n    });\n    if(values != null) $('#slider-up_to-25-lbl').text(values[$('#slider-up_to-25').slider('value')]);\n    }, 1); })();</script></td></tr>\n</table><div id=\"cell-interact-25\"><?__SAGE__START>\n        <table border=0 bgcolor=\"white\" width=100% height=100%>\n        <tr><td bgcolor=\"white\" align=left valign=top><pre><?__SAGE__TEXT></pre></td></tr>\n        <tr><td  align=left valign=top><?__SAGE__HTML></td></tr>\n        </table><?__SAGE__END></div></td>\n                 </tr></table></div>\n                 "}︡
︠b2b13a05-7221-475d-b70f-a3aaabc751b0i︠
%html
<p><strong>Idle Question: &nbsp;</strong>Is there an elementary argument that the percentage of failures go to 0 as $n\to\infty$?</p>

︡90cbf401-1a62-457b-8b27-f024a1384ac2︡{"html": "<p><strong>Idle Question: &nbsp;</strong>Is there an elementary argument that the percentage of failures go to 0 as $n\\to\\infty$?</p>"}︡
︠9dac9a72-d905-40bf-8a93-15acd349c7c6i︠
%html
<h1><strong>Finding a Charmichael Number</strong></h1>

︡c808b8bf-569c-4f1e-8e70-1f1eb8579622︡{"html": "<h1><strong>Finding a Charmichael Number</strong></h1>"}︡
︠597388b3-4619-4268-8ede-0ee45db4c2a6a︠
%auto
def is_charmichael_number(n):
    if is_prime(n): return False
    for a in [2..n]:
        if gcd(a,n) == 1:
            if a.powermod(n-1,n) != 1: return False
    return True
︡898e6146-4066-4cbb-8bb2-30f8476cbf0b︡︡
︠d8a96de9-df8e-4759-955e-fea415e7f016︠
for n in [2..7000]:
    if is_charmichael_number(n):
        print "n = %s"%n
︡1a8266a4-8110-4ef5-ab61-3934ba22f5a6︡{"stdout": "n = 561\nn = 1105\nn = 1729\nn = 2465\nn = 2821\nn = 6601"}︡
︠9811f7cd-f388-40fa-8913-649434f60446︠
12^3 + 1^3
︡0864eeb2-3b74-4e2f-bd11-4f72c24bcd45︡{"stdout": "1729"}︡
︠7bf93cdc-83ba-4a46-9edc-4a2ce61fd2ebi︠
%html
<h1>Miller-Rabin</h1>
<p>An extremely powerful probabilistic primality test. &nbsp;Every call increases the chances of a correct conclusion.</p>

︡c527bdde-d2e0-4806-a9e6-aac98868ea16︡{"html": "<h1>Miller-Rabin</h1>\r\n<p>An extremely powerful probabilistic primality test. &nbsp;Every call increases the chances of a correct conclusion.</p>"}︡
︠5f27a2fc-9b77-4130-ad79-e9d945a593e2a︠
%auto
def miller_rabin_round(n):
    k = valuation(n-1, 2)
    m = (n-1)//2^k
    a = ZZ.random_element(x=2,y=n-1)
    b = a.powermod(m,n)
    if b == 1 or b == n-1: return True
    for r in [1..k-1]:
        if b.powermod(2^r,n) == n-1: return True
    return False
    
def miller_rabin(n, rounds=10):
    for i in range(rounds):
        if not miller_rabin_round(n): return False
    return True
︡1e1f9169-f286-40fc-b199-1251b58deb0a︡︡
︠bed1fbb5-1825-4c18-bd55-b675aeae34d7a︠
%auto
@interact
def _(nmax=1000, rounds=[1..5], retry=['Go!']):
    print "Failures up to %s: "%nmax,
    k = 0
    for n in [5..nmax]:
        if miller_rabin(n,rounds) != is_prime(n):
            print n,
            k += 1
    if k == 0: print "None"
︡0134db25-4622-4566-9ea4-74deab1e5b4b︡{"html": "<!--notruncate--><div padding=6 id=\"div-interact-23\"> <table width=800px height=20px bgcolor=\"#c5c5c5\"\n                 cellpadding=15><tr><td bgcolor=\"#f9f9f9\" valign=top align=left><table><tr><td align=right><font color=\"black\">nmax&nbsp;</font></td><td><input type=\"text\" value=\"1000\" size=80 onchange=\"interact(23, '_interact_.update(\\'23\\', \\'nmax\\', 5, _interact_.standard_b64decode(\\''+encode64(this.value)+'\\'), globals()); _interact_.recompute(\\'23\\');')\"></input></td></tr>\n<tr><td align=right><font color=\"black\">rounds&nbsp;</font></td><td><table style=\"border:1px solid #dfdfdf; background-color:#efefef;\">\n<tr><td><button style=\"border-style:inset;\" value=\"0\" onclick=\"$('BUTTON', this.parentNode).css('border-style', 'outset'); $(this).css('border-style', 'inset'); interact(23, '_interact_.update(\\'23\\', \\'rounds\\', 6, _interact_.standard_b64decode(\\''+encode64(this.value)+'\\'), globals()); _interact_.recompute(\\'23\\');')\">1</button>\n<button style=\"border-style:outset;\" value=\"1\" onclick=\"$('BUTTON', this.parentNode).css('border-style', 'outset'); $(this).css('border-style', 'inset'); interact(23, '_interact_.update(\\'23\\', \\'rounds\\', 6, _interact_.standard_b64decode(\\''+encode64(this.value)+'\\'), globals()); _interact_.recompute(\\'23\\');')\">2</button>\n<button style=\"border-style:outset;\" value=\"2\" onclick=\"$('BUTTON', this.parentNode).css('border-style', 'outset'); $(this).css('border-style', 'inset'); interact(23, '_interact_.update(\\'23\\', \\'rounds\\', 6, _interact_.standard_b64decode(\\''+encode64(this.value)+'\\'), globals()); _interact_.recompute(\\'23\\');')\">3</button>\n<button style=\"border-style:outset;\" value=\"3\" onclick=\"$('BUTTON', this.parentNode).css('border-style', 'outset'); $(this).css('border-style', 'inset'); interact(23, '_interact_.update(\\'23\\', \\'rounds\\', 6, _interact_.standard_b64decode(\\''+encode64(this.value)+'\\'), globals()); _interact_.recompute(\\'23\\');')\">4</button>\n<button style=\"border-style:outset;\" value=\"4\" onclick=\"$('BUTTON', this.parentNode).css('border-style', 'outset'); $(this).css('border-style', 'inset'); interact(23, '_interact_.update(\\'23\\', \\'rounds\\', 6, _interact_.standard_b64decode(\\''+encode64(this.value)+'\\'), globals()); _interact_.recompute(\\'23\\');')\">5</button>\n</td></tr></table></td></tr>\n<tr><td align=right><font color=\"black\">retry&nbsp;</font></td><td><table style=\"border:1px solid #dfdfdf; background-color:#efefef;\">\n<tr><td><button style=\"border-style:outset;\" value=\"0\" onclick=\"interact(23, '_interact_.update(\\'23\\', \\'retry\\', 7, _interact_.standard_b64decode(\\''+encode64(this.value)+'\\'), globals()); _interact_.recompute(\\'23\\');')\">Go!</button>\n</td></tr></table></td></tr>\n</table><div id=\"cell-interact-23\"><?__SAGE__START>\n        <table border=0 bgcolor=\"white\" width=100% height=100%>\n        <tr><td bgcolor=\"white\" align=left valign=top><pre><?__SAGE__TEXT></pre></td></tr>\n        <tr><td  align=left valign=top><?__SAGE__HTML></td></tr>\n        </table><?__SAGE__END></div></td>\n                 </tr></table></div>\n                 "}︡
